/*
 * Project name:
     KeyPad on LED
 * Copyright:
     (c) Mikroelektronika, 2010.
 * Revision History:
     20101007:
       - initial release;
       - 20101007 - Ranko Rankovic;
 * Description:
     This project will demonstrate how keys pressed on KeyPad are written on LED.
 * Test configuration:
     MCU:             ac:ATmega16
     Dev.Board:       ac:EasyAVR6

     Oscillator:      HS, 8.0000 MHz
     Ext. Modules:    ac:KeyPad_4x4_Module
     SW:              ac:mikroC_PRO_for_AVR_v3.50
 * NOTES:
     - Turn on LEDs on PortB and PortC (SW8.2 and SW8.3)
     - Connect KeyPad on PortA
*/




unsigned short kp, cnt, oldstate = 0;
char txt[6];

// Keypad module connections
char  keypadPort at PORTA;
char  keypadPort_Direction at DDRA;
// End Keypad module connections


void main() {
  cnt = 0;                                     // Reset counter
  Keypad_Init();                               // Initialize Keypad

  do {
    kp = 0;                                    // Reset key code variable

    // Wait for key to be pressed and released
    do

  kp = Keypad_Key_Click();             // Store key code in kp variable
  while (!kp);
   // Prepare value for output, transform key to it's ASCII value
    switch (kp) {

      case  1: kp = 49; break; // 1
      case  2: kp = 50; break; // 2
      case  3: kp = 51; break; // 3
      case  4: kp = 65; break; // A
      case  5: kp = 52; break; // 4
      case  6: kp = 53; break; // 5
      case  7: kp = 54; break; // 6
      case  8: kp = 66; break; // B
      case  9: kp = 55; break; // 7
      case 10: kp = 56; break; // 8
      case 11: kp = 57; break; // 9
      case 12: kp = 67; break; // C
      case 13: kp = 42; break; // *
      case 14: kp = 48; break; // 0
      case 15: kp = 35; break; // #
      case 16: kp = 68; break; // D

    }

    if (kp != oldstate) {                  // Pressed key differs from previous
      cnt = 1;
      oldstate = kp;
    }
    else {                                 // Pressed key is same as previous
      cnt++;
    }

    PORTB = kp;                    // Print key ASCII value on LCD

    if (cnt == 255) {                      // If counter varialble overflow
      cnt = 0;
      PORTC = cnt;
    }

    PORTC = cnt;                   // Display counter value on LCD
  } while (1);
}